import matplotlib.pyplot as plt
import numpy as np

import random

import string # Pour l'exo 3 avec le bonus

"""""""""""""""""
CheatSheet :


plt.subplot(nb_lignes, nb_colonnes, position) où position <= nb_lignes*nb_colonnes

"""""""""""""""""

def exo1():
    """
    Afficher la courbe y = f(x) pour plusieurs fonctions f.
    """
    X = np.linspace(-10, 10, 500) # 500 points entre -10 et 10

    def poly2(x):
        return x**2 + 3*x -1

    def f(t):
        return np.exp(-t) * np.cos(2*np.pi*t)
    
    # Ouvre une nouvelle figure, par défaut figure(1)
    plt.figure()

    # On partage la figure en 2 lignes, 2 colonnes, et on sélectionne la première.
    plt.subplot(2, 2, 1)
    plt.plot(X, poly2(X), "r")
    plt.legend(("Polynôme du 2nd degré",))
    
    # On passe au coin en haut à droite
    plt.subplot(2, 2, 2)
    plt.plot(X, np.sqrt(np.abs(X)), "k")
    plt.legend(("Haut à droite",))


    # On passe au coin en bas à gauche, on dessine un log
    plt.subplot(2, 2, 3)
    X2 = np.linspace(0.01, 10, 500)
    plt.plot(X, np.log(X2), "g")
    plt.legend(("Bas à gauche : Un log",))

    # On passe au coin en bas à droite
    plt.subplot(2, 2, 4)
    X2 = np.linspace(0, 10, 500)
    plt.plot(X, f(X2))
    plt.legend(("En bas à droite : La fonction f",))


    plt.show()
    


def exo2(n = 500):
    """
    L'objectif est d'afficher une marche aléatoire
    """

    x=[0]
    y=[0]
    a=0
    b=0
    j=0
    for i in range(0,n):
        k=random.randint(0,3)
        if k==1:#on va à l Est
            a+=1
            b=b
            x.append(a)
            y.append(b)
        elif k==0:#on va au Sud
            a=a
            b-=1
            x.append(a)
            y.append(b)
        elif k==2:#on va à l'Ouest
            a-=1
            b=b
            x.append(a)
            y.append(b)
        else: #on va au Nord
            a=a
            b+=1
            x.append(a)
            y.append(b)
    fig, ax = plt.subplots()
    ax.spines['right'].set_color('none')
    ax.spines['top'].set_color('none')
    ax.xaxis.set_ticks_position('bottom')
    ax.spines['bottom'].set_position(('data',0))
    ax.yaxis.set_ticks_position('left')
    ax.spines['left'].set_position(('data',0))
    plt.plot(x,y)
    plt.title("Marche aléatoire dans le plan pour {} pas".format(n))
    plt.plot([0],[0],'red')
    plt.show()


    
    



def exo3():
    """
    Ecrire un programme qui ouvre un fichier texte de votre choix, puis produit le dictionnaire associant à chaque mot présent son nombre d'occurences dans le texte.
        
    Afficher le résultat sous forme d'un diagramme en bâton qui montre le nombre d'occurence des dix mots les plus présents dans le texte.
    """
    txt = open("MyText.txt", "r")
    dico = {}
    lignes = txt.readlines()

    for ligne in lignes:
            
        # On vire les blancs à la fin
        ligne = ligne.strip()

        # On met tous les mots en minuscule pour comparer ce qui est comparable
        ligne = ligne.lower()

        # On supprime les signes de ponctuation : Pour moi "monde" = "monde,"
        # C'est facultatif mais l'un d'entre vous me l'a demandé pour un projet perso.
        ligne = ligne.strip(string.punctuation)

        # On récupère les mots
        mots = ligne.split()
            
        for mot in mots:
            # On utilise l'astuce du dico.get déjà vu en TD précédemment
            dico[mot] = dico.get(mot, 0) + 1
                
    # On trie le dictionnaire par valeur maximale
    l = sorted(dico.items(), key = lambda x: x[1], reverse = True)
    
    # On filtre les mots d'une lettre qui ne sont pas pertinents pour l'étude
    l = filter(lambda x: len(x[0]) > 1, l)

    l = list(l)[:10]

    mots = list(map(lambda x: x[0], l))
    occurences = list(map(lambda x: x[1], l))
    
    
    # Ce qui suit est un bonus si vous voulez mettre les valeurs en haut des bâtons
    # x = range(len(mots))

    # fig, ax = plt.subplots()
    # batons = ax.bar(x, occurences, width=0.4)
    # plt.xticks(x, mots)
    
    # for baton in batons:
    #    valeur = baton.get_height()
    #    ax.text(baton.get_x() + baton.get_width()/2., 1.01*valeur, "{}".format(int(valeur)),
    #            ha = "center")
    
    
    # Si vous voulez juste afficher les batons, alors on peut simplement faire ça :
    
    
    plt.bar(mots, occurences)
    
    plt.show()

            
